/** ***************************************************************************
 * @file  Display.cpp
 * @brief DisplayNX̎
 * @author Hidekazu Ito
 * @date 2015/02/28
 ******************************************************************************/

#include "Display.h"

using Win32Utility::Display;

/** *****************************************************************
 * @brief ݂̃fBXvC̐ݒ擾
 * @retval DEVMODE fBXvCݒ
 ********************************************************************/
DEVMODE Display::GetCurrentSettings()
{
    DEVMODE devMode={0u};
    EnumDisplaySettings(NULL, ENUM_CURRENT_SETTINGS, &devMode);
    return devMode;
}

/** *****************************************************************
 * @brief OtBbNX[h̐ݒ萔擾
 * @retval DWORD [h
 ********************************************************************/
DWORD Display::GetModeNum()
{
    DEVMODE devMode={0u};
    DWORD num = 0;
    while (FALSE != EnumDisplaySettings(NULL, num, &devMode)) {
        num++;
    }
    return num;
}

/** *****************************************************************
 * @brief OtBbNX[h̐ݒ擾
 * @retval DEVMODE [hݒ
 ********************************************************************/
DEVMODE Display::GetModeSettings(DWORD modeIndex)
{
    DEVMODE devMode={0u};
    EnumDisplaySettings(NULL, modeIndex, &devMode);
    return devMode;
}

/** *****************************************************************
 * @brief fBXvC̃foCXݒ
 * @param[in,out] lpDevMode  ݒ肷OtBbNX[h
 * @param[in]     flags      ύX@wi0:IύXȂChangeDisplaySettings̃}jAQƁj
 * @retval LONG ʒli:DISP_CHANGE_SUCCESSFULȂChangeDisplaySettings̃}jAQƁj
 ********************************************************************/
LONG Display::SetSettings(LPDEVMODE lpDevMode, DWORD flags)
{
    return ChangeDisplaySettings(lpDevMode, flags);
}

/** *****************************************************************
 * @brief fBXvC̃foCXݒ
 * @param[in] bits   rbgw
 * @param[in] width  w
 * @param[in] height w
 * @param[in] flags  ύX@wi0:IύXȂChangeDisplaySettings̃}jAQƁj
 * @retval LONG ʒli:DISP_CHANGE_SUCCESSFULȂChangeDisplaySettings̃}jAQƁj
 ********************************************************************/
LONG Display::SetSettings(DWORD bits, DWORD width, DWORD height, DWORD flags)
{
    DEVMODE devMode = {0u};
    devMode.dmSize             = sizeof(DEVMODE);
    devMode.dmBitsPerPel       = bits;
    devMode.dmPelsWidth        = width;
    devMode.dmPelsHeight       = height;
    devMode.dmFields           = DM_BITSPERPEL | DM_PELSWIDTH | DM_PELSHEIGHT;
    return SetSettings(&devMode, flags);
}

/** *****************************************************************
 * @brief fBXvC̃foCXݒ
 * @param[in] modeIndex  OtBbNX[hԍw
 * @param[in] flags  ύX@wi0:IύXȂChangeDisplaySettings̃}jAQƁj
 * @retval LONG ʒli:DISP_CHANGE_SUCCESSFULȂChangeDisplaySettings̃}jAQƁj
 ********************************************************************/
LONG Display::SetSettings(DWORD modeIndex, DWORD flags)
{
    DEVMODE devMode={0u};
    if (FALSE == EnumDisplaySettings(NULL, modeIndex, &devMode)) {
        return DISP_CHANGE_BADMODE;
    }
    return ChangeDisplaySettings(&devMode, flags);
}

// EOF